<h1 align="center">🏦 Long Banking System 🏦 </h1>
<p align="center">using <b>Python 🐍</b></p><br>
<p align="center">
  <img src="https://img.shields.io/static/v1?label=%F0%9F%8C%9F&message=If%20Useful&style=style=flat&color=BC4E99" alt="Star Badge"/>
  <a href="https://www.github.com/dolong2110">
    <img src="https://img.shields.io/github/followers/dolong2110?style=social&link=https://www.github.com/dolong2110" alt="GitHub"/>
  </a>
</p>
<br>

## 📃 Table of Contents:
  - [About Project](#-about-project)
  - [System Design](#-system-design)
  - [Screenshot](#-screenshot)
  - [Install](#-install)

<br>

## 🖋 About Project:
👉 An online banking system built using Python. This system allows the customer - user privilege, and banking staff/manager - admin privilege, to manage all transactions easily. <br>
👉 It performs basic services of an online banking system: authentication, transaction, etc. <br>
👉 It practices with many algorithm and data structures: queue, double linked-list, various sorting algorithms. <br>
👉 As mentioned above, there are 2 users for this system:
1. **Admin**:
    - Can **do basic authentication** such as login, create, delete
    - Can **view and search customer profile**
    - Can **read customers' feedback**
2. **User**:
    - Can **do basic authentication**  such as login, create, delete
    - Can **do the transactions**
    - Can **send the feedbacks**

> Note: **Every user needs to create account and sign in to access the system. All the data must be stored in json (.json) files.**<br>

[![](https://img.shields.io/badge/back%20to%20top-%E2%86%A9-red)](#-table-of-contents)
<br><br>

## 💻 System Design:
👉 In this online banking system, there are 11 different menus, namely:
1. **Main Menu**
2. **Admin**
    - Admin Login
    - Admin Menu
    - Admin New Profile
    - Admin Search Customer Data
    - Admin Search Customer Transaction
3. **Customer**
    - Customer Login
    - Customer Menu
    - Customer Deposit 
    - Customer Withdraw
    - Customer View
<br><br>
[![](https://img.shields.io/badge/back%20to%20top-%E2%86%A9-red)](#-table-of-contents)
<br><br>

## 📷 Screenshot:

<br><br>
[![](https://img.shields.io/badge/back%20to%20top-%E2%86%A9-red)](#-table-of-contents)
<br><br>

## Install:
- First clone the repo

```
git clone https://github.com/dolong2110/long-banking-system.git
```

- Install pip

```
py -m pip install --upgrade pip
py -m pip --version
```

- Install virtualenv

```
py -m pip install --user virtualenv
```

- Move current directory to the project directory

```
cd ..\long-banking-system
```

- Create a virtual environment

```
py -m venv bank-system-env
```

- Activating the virtual environment

```
.\env\Scripts\activate
```

- Install all dependencies

```
pip install -r requirements.txt
```

- Run as an user

```
py main.py
```

- Run as an admin

```
py admin.py
```

<br><br>
[![](https://img.shields.io/badge/back%20to%20top-%E2%86%A9-red)](#-table-of-contents)
<br><br>

## 🙌 Support me!

👉 If you find this project useful, **please ⭐ this repository 😆**!

[![](https://img.shields.io/badge/back%20to%20top-%E2%86%A9-red)](#-table-of-contents)
<br>